searchNodes=[{"doc":"Provides functions to create composable and bidirectional serializers. Installation def deps do [ { :bin_codex , &quot;~&gt; 0.1.0&quot; } ] end Usage The BinCodex module provides a number of predefined codecs and combinators that you can use to build new codes. iex&gt; first_codec = sequence ( [ byte ( ) , byte ( ) , byte ( ) ] ) ...&gt; &lt;&lt; 0x10 , 0xFF , 0xAB &gt;&gt; |&gt; decode ( first_codec ) { :ok , [ 16 , 255 , 171 ] , &lt;&lt; &gt;&gt; } ...&gt; [ 16 , 255 , 171 ] |&gt; encode ( first_codec ) { :ok , &lt;&lt; 0x10 , 0xFF , 0xAB &gt;&gt; } Inspiration This library draws inspiration from https://github.com/scodec/scodec","ref":"BinCodex.html","title":"BinCodex","type":"module"},{"doc":"Appends a list codec with a codec to form a new list. Examples iex&gt; codec = list_of ( 3 , byte ( ) ) |&gt; append ( bits ( 4 ) ) ...&gt; [ 1 , 2 , 3 , 4 ] |&gt; encode ( codec ) { :ok , &lt;&lt; 1 , 2 , 3 , 4 :: 4 &gt;&gt; } ...&gt; &lt;&lt; 1 , 2 , 3 , 4 :: 4 &gt;&gt; |&gt; decode ( codec ) { :ok , [ 1 , 2 , 3 , 4 ] , &lt;&lt; &gt;&gt; }","ref":"BinCodex.html#append/2","title":"BinCodex.append/2","type":"function"},{"doc":"Encodes/decodes a single bit as either 0 or 1. Examples iex&gt; &lt;&lt; 1 :: 1 &gt;&gt; |&gt; decode ( bit ( ) ) { :ok , 1 , &lt;&lt; &gt;&gt; } iex&gt; &lt;&lt; 0 :: 1 &gt;&gt; |&gt; decode ( bit ( ) ) { :ok , 0 , &lt;&lt; &gt;&gt; } iex&gt; 1 |&gt; encode ( bit ( ) ) { :ok , &lt;&lt; 1 :: 1 &gt;&gt; } iex&gt; 0 |&gt; encode ( bit ( ) ) { :ok , &lt;&lt; 0 :: 1 &gt;&gt; } iex&gt; 2 |&gt; encode ( bit ( ) ) { :error , &quot;2 cannot be encoded in 1 bits&quot; }","ref":"BinCodex.html#bit/0","title":"BinCodex.bit/0","type":"function"},{"doc":"Encodes/decodes a series of bits as an unsigned integer. Examples iex&gt; &lt;&lt; 3 :: 7 &gt;&gt; |&gt; decode ( bits ( 7 ) ) { :ok , 3 , &lt;&lt; &gt;&gt; } iex&gt; 5 |&gt; encode ( bits ( 7 ) ) { :ok , &lt;&lt; 5 :: 7 &gt;&gt; } iex&gt; 300 |&gt; encode ( bits ( 7 ) ) { :error , &quot;300 cannot be encoded in 7 bits&quot; }","ref":"BinCodex.html#bits/1","title":"BinCodex.bits/1","type":"function"},{"doc":"","ref":"BinCodex.html#bits_remaining/0","title":"BinCodex.bits_remaining/0","type":"function"},{"doc":"Encodes/decodes a single bit as either true (if 1) or false (if 0). Examples iex&gt; &lt;&lt; 1 :: 1 &gt;&gt; |&gt; decode ( bool_bit ( ) ) { :ok , true , &lt;&lt; &gt;&gt; } iex&gt; &lt;&lt; 0 :: 1 &gt;&gt; |&gt; decode ( bool_bit ( ) ) { :ok , false , &lt;&lt; &gt;&gt; } iex&gt; true |&gt; encode ( bool_bit ( ) ) { :ok , &lt;&lt; 1 :: 1 &gt;&gt; } iex&gt; false |&gt; encode ( bool_bit ( ) ) { :ok , &lt;&lt; 0 :: 1 &gt;&gt; }","ref":"BinCodex.html#bool_bit/0","title":"BinCodex.bool_bit/0","type":"function"},{"doc":"Encodes/decodes a single byte as an unsigned integer. Examples iex&gt; &lt;&lt; 123 &gt;&gt; |&gt; decode ( byte ( ) ) { :ok , 123 , &lt;&lt; &gt;&gt; } iex&gt; 210 |&gt; encode ( byte ( ) ) { :ok , &lt;&lt; 210 &gt;&gt; } iex&gt; 400 |&gt; encode ( byte ( ) ) { :error , &quot;400 cannot be encoded in 8 bits&quot; }","ref":"BinCodex.html#byte/0","title":"BinCodex.byte/0","type":"function"},{"doc":"Encodes/decodes a series of bytes as an unsigned integer. Examples iex&gt; &lt;&lt; 1 , 2 &gt;&gt; |&gt; decode ( bytes ( 2 ) ) { :ok , 258 , &lt;&lt; &gt;&gt; } iex&gt; 258 |&gt; encode ( bytes ( 2 ) ) { :ok , &lt;&lt; 1 , 2 &gt;&gt; }","ref":"BinCodex.html#bytes/1","title":"BinCodex.bytes/1","type":"function"},{"doc":"Tries to encode/decode each codec in succession, using the first one that succeeds. Examples iex&gt; &lt;&lt; 1 &gt;&gt; |&gt; decode ( choice ( [ byte ( ) , bits ( 4 ) ] ) ) { :ok , 1 , &lt;&lt; &gt;&gt; } iex&gt; &lt;&lt; 1 :: 4 &gt;&gt; |&gt; decode ( choice ( [ byte ( ) , bits ( 4 ) ] ) ) { :ok , 1 , &lt;&lt; &gt;&gt; } iex&gt; &lt;&lt; 1 :: 2 &gt;&gt; |&gt; decode ( choice ( [ byte ( ) , bits ( 4 ) ] ) ) { :error , &quot;None of the choices worked&quot; , &lt;&lt; 1 :: 2 &gt;&gt; }","ref":"BinCodex.html#choice/1","title":"BinCodex.choice/1","type":"function"},{"doc":"Combines two codecs into a codec that produces a 2-element tuple of each value. Examples iex&gt; { 198 , 2 } |&gt; encode ( combine ( byte ( ) , byte ( ) ) ) { :ok , &lt;&lt; 198 , 2 &gt;&gt; } iex&gt; &lt;&lt; 198 , 2 &gt;&gt; |&gt; decode ( combine ( byte ( ) , byte ( ) ) ) { :ok , { 198 , 2 } , &lt;&lt; &gt;&gt; }","ref":"BinCodex.html#combine/2","title":"BinCodex.combine/2","type":"function"},{"doc":"Combines a codec with a list codec to form a new list. Examples iex&gt; non_empty_list = byte ( ) |&gt; cons ( list ( byte ( ) ) ) ...&gt; [ 1 ] |&gt; encode ( non_empty_list ) { :ok , &lt;&lt; 1 &gt;&gt; } ...&gt; [ ] |&gt; encode ( non_empty_list ) { :error , &quot;Failed to encode []&quot; } ...&gt; &lt;&lt; 1 &gt;&gt; |&gt; decode ( non_empty_list ) { :ok , [ 1 ] , &lt;&lt; &gt;&gt; } ...&gt; &lt;&lt; &gt;&gt; |&gt; decode ( non_empty_list ) { :error , &quot;Could not decode 8 bits from \\&quot; \\&quot; &quot; , &lt;&lt; &gt;&gt; }","ref":"BinCodex.html#cons/2","title":"BinCodex.cons/2","type":"function"},{"doc":"A codec that always encodes to and decodes from the same value. It fails if it doesn't see the expected value that it always encodes/decodes. Examples iex&gt; &lt;&lt; 200 &gt;&gt; |&gt; decode ( constant ( 10 , &lt;&lt; 200 &gt;&gt; ) ) { :ok , 10 , &lt;&lt; &gt;&gt; } iex&gt; &lt;&lt; 234 &gt;&gt; |&gt; decode ( constant ( 10 , &lt;&lt; 200 &gt;&gt; ) ) { :error , &quot;&lt;&lt;234&gt;&gt; did not equal &lt;&lt;200&gt;&gt; in constant&quot; , &lt;&lt; 234 &gt;&gt; } iex&gt; 10 |&gt; encode ( constant ( 10 , &lt;&lt; 200 &gt;&gt; ) ) { :ok , &lt;&lt; 200 &gt;&gt; } iex&gt; 22 |&gt; encode ( constant ( 10 , &lt;&lt; 200 &gt;&gt; ) ) { :error , &quot;22 did not equal 10 in constant&quot; }","ref":"BinCodex.html#constant/2","title":"BinCodex.constant/2","type":"function"},{"doc":"Used to convert a codec to another type. Must also be used with caution to make sure your conversion is idempotent. Examples defmodule Foo do defstruct a : nil , b : nil end iex&gt; tuple_codec = combine ( byte ( ) , byte ( ) ) ...&gt; struct_codec = tuple_codec |&gt; convert ( fn { a , b } -&gt; % Foo { a : a , b : b } end , fn % Foo { a : a , b : b } -&gt; { a , b } end ) ...&gt; &lt;&lt; 12 , 34 &gt;&gt; |&gt; decode ( struct_codec ) { :ok , % Foo { a : 12 , b : 34 } , &lt;&lt; &gt;&gt; } ...&gt; % Foo { a : 12 , b : 34 } |&gt; encode ( struct_codec ) { :ok , &lt;&lt; 12 , 34 &gt;&gt; }","ref":"BinCodex.html#convert/3","title":"BinCodex.convert/3","type":"function"},{"doc":"Creates a new codec. It is recommended to use the other well-tested functions in the module to build a codec instead of creating your own unless you absolutely have to. When creating your own codec it MUST be idempotent. Examples iex&gt; BinCodex . create ( fn _ -&gt; { :ok , &lt;&lt; &gt;&gt; } end , fn ...&gt; &lt;&lt; &gt;&gt; -&gt; { :ok , false , &lt;&lt; &gt;&gt; } ...&gt; bits -&gt; { :ok , true , bits } ...&gt; end ) # BinCodex &lt; ... &gt;","ref":"BinCodex.html#create/2","title":"BinCodex.create/2","type":"function"},{"doc":"Decodes a value from its binary form using the supplied codec. The third element of the tuple is any remaining unparsed bits. Examples iex&gt; &lt;&lt; 198 &gt;&gt; |&gt; decode ( byte ( ) ) { :ok , 198 , &lt;&lt; &gt;&gt; }","ref":"BinCodex.html#decode/2","title":"BinCodex.decode/2","type":"function"},{"doc":"Only succeeds if there were no bits left to parse. Examples iex&gt; &lt;&lt; 10 &gt;&gt; |&gt; decode ( byte ( ) |&gt; done ( ) ) { :ok , 10 , &lt;&lt; &gt;&gt; } iex&gt; &lt;&lt; 10 , 11 &gt;&gt; |&gt; decode ( byte ( ) |&gt; done ( ) ) { :error , &quot;There was more to parse&quot; , &lt;&lt; 11 &gt;&gt; }","ref":"BinCodex.html#done/1","title":"BinCodex.done/1","type":"function"},{"doc":"A codec that always decodes to an empty list, [] . It can never fail decoding. Examples iex&gt; defmodule EmptyExample do ...&gt; def listify ( [ ] ) , do : empty ( ) ...&gt; def listify ( [ codec | rest ] ) , do : codec |&gt; cons ( listify ( rest ) ) ...&gt; end ...&gt; &lt;&lt; 1 &gt;&gt; |&gt; decode ( EmptyExample . listify ( [ ] ) ) { :ok , [ ] , &lt;&lt; 1 &gt;&gt; } ...&gt; &lt;&lt; 22 , 38 &gt;&gt; |&gt; decode ( EmptyExample . listify ( [ byte ( ) , byte ( ) ] ) ) { :ok , [ 22 , 38 ] , &lt;&lt; &gt;&gt; }","ref":"BinCodex.html#empty/0","title":"BinCodex.empty/0","type":"function"},{"doc":"Encodes a value to its binary form using the supplied codec. Examples iex&gt; 198 |&gt; encode ( byte ( ) ) { :ok , &lt;&lt; 198 &gt;&gt; }","ref":"BinCodex.html#encode/2","title":"BinCodex.encode/2","type":"function"},{"doc":"Fails a codec if the result doesn't satisfy the predicate. Examples iex&gt; codec = byte ( ) |&gt; ensure ( &amp; &amp;1 &gt; 10 , &quot;Must be greater than 10&quot; ) ...&gt; 5 |&gt; encode ( codec ) { :error , &quot;Must be greater than 10&quot; } ...&gt; 11 |&gt; encode ( codec ) { :ok , &lt;&lt; 11 &gt;&gt; } ...&gt; &lt;&lt; 5 &gt;&gt; |&gt; decode ( codec ) { :error , &quot;Must be greater than 10&quot; } ...&gt; &lt;&lt; 11 &gt;&gt; |&gt; decode ( codec ) { :ok , 11 , &lt;&lt; &gt;&gt; }","ref":"BinCodex.html#ensure/3","title":"BinCodex.ensure/3","type":"function"},{"doc":"Creates a codec that always fails with the supplied error message. This is not useful on its own but can be useful when building other codecs. Examples iex&gt; defmodule FailExample do ...&gt; def choose ( [ ] ) , do : fail ( &quot;None of the choices worked&quot; ) ...&gt; def choose ( [ codec | rest ] ) , do : fallback ( codec , choice ( rest ) ) ...&gt; end ...&gt; codec = FailExample . choose ( [ byte ( ) , bits ( 4 ) ] ) ...&gt; &lt;&lt; 1 &gt;&gt; |&gt; decode ( codec ) { :ok , 1 , &lt;&lt; &gt;&gt; } ...&gt; &lt;&lt; 1 :: 2 &gt;&gt; |&gt; decode ( codec ) { :error , &quot;None of the choices worked&quot; , &lt;&lt; 1 :: 2 &gt;&gt; }","ref":"BinCodex.html#fail/1","title":"BinCodex.fail/1","type":"function"},{"doc":"Creates a codec that always fails with the supplied error messages. Same as fail/1 but you can supply a different error message for encoding and decoding.","ref":"BinCodex.html#fail/2","title":"BinCodex.fail/2","type":"function"},{"doc":"Uses the first codec, falling back to the second if it fails. Examples iex&gt; optional_byte = byte ( ) |&gt; fallback ( nothing ( ) ) ...&gt; &lt;&lt; 8 &gt;&gt; |&gt; decode ( optional_byte ) { :ok , 8 , &lt;&lt; &gt;&gt; } ...&gt; &lt;&lt; 8 :: 4 &gt;&gt; |&gt; decode ( optional_byte ) { :ok , nil , &lt;&lt; 8 :: 4 &gt;&gt; }","ref":"BinCodex.html#fallback/2","title":"BinCodex.fallback/2","type":"function"},{"doc":"","ref":"BinCodex.html#join/2","title":"BinCodex.join/2","type":"function"},{"doc":"Uses length_codec to determine the number of codec to evaluate as a list. Examples iex&gt; [ 1 , 2 , 3 , 4 ] |&gt; encode ( length_prefixed ( byte ( ) , byte ( ) ) ) { :ok , &lt;&lt; 4 , 1 , 2 , 3 , 4 &gt;&gt; } iex&gt; &lt;&lt; 4 , 1 , 2 , 3 , 4 &gt;&gt; |&gt; decode ( length_prefixed ( byte ( ) , byte ( ) ) ) { :ok , [ 1 , 2 , 3 , 4 ] , &lt;&lt; &gt;&gt; }","ref":"BinCodex.html#length_prefixed/2","title":"BinCodex.length_prefixed/2","type":"function"},{"doc":"Repeatedly evaluates codec and accumulates the result into a list. Examples iex&gt; [ 1 , 2 , 3 , 4 ] |&gt; encode ( list ( byte ( ) ) ) { :ok , &lt;&lt; 1 , 2 , 3 , 4 &gt;&gt; } iex&gt; [ ] |&gt; encode ( list ( byte ( ) ) ) { :ok , &lt;&lt; &gt;&gt; } iex&gt; &lt;&lt; &gt;&gt; |&gt; decode ( list ( byte ( ) ) ) { :ok , [ ] , &lt;&lt; &gt;&gt; }","ref":"BinCodex.html#list/1","title":"BinCodex.list/1","type":"function"},{"doc":"Decodes a list of codec of length count . Examples iex&gt; [ 1 , 2 , 3 , 4 ] |&gt; encode ( list_of ( 4 , byte ( ) ) ) { :ok , &lt;&lt; 1 , 2 , 3 , 4 &gt;&gt; } iex&gt; &lt;&lt; 1 , 2 , 3 , 4 , 5 &gt;&gt; |&gt; decode ( list_of ( 4 , byte ( ) ) ) { :ok , [ 1 , 2 , 3 , 4 ] , &lt;&lt; 5 &gt;&gt; }","ref":"BinCodex.html#list_of/2","title":"BinCodex.list_of/2","type":"function"},{"doc":"Tests whether a codec would succeed. Decodes to true if it would, false otherwise. Similar to recover/1 except it doesn't consume the bits when it succeeds and returns true . Examples iex&gt; &lt;&lt; 38 &gt;&gt; |&gt; decode ( lookahead ( byte ( ) ) ) { :ok , true , &lt;&lt; 38 &gt;&gt; } iex&gt; &lt;&lt; 1 :: 1 &gt;&gt; |&gt; decode ( lookahead ( byte ( ) ) ) { :ok , false , &lt;&lt; 1 :: 1 &gt;&gt; }","ref":"BinCodex.html#lookahead/1","title":"BinCodex.lookahead/1","type":"function"},{"doc":"Uses the two mapping functions to convert each element of a list codec. Examples iex&gt; codec = list ( byte ( ) ) |&gt; map_list ( &amp; &amp;1 + 1 , &amp; &amp;1 - 1 ) ...&gt; &lt;&lt; 10 , 11 , 12 &gt;&gt; |&gt; decode ( codec ) { :ok , [ 11 , 12 , 13 ] , &lt;&lt; &gt;&gt; } ...&gt; [ 11 , 12 , 13 ] |&gt; encode ( codec ) { :ok , &lt;&lt; 10 , 11 , 12 &gt;&gt; }","ref":"BinCodex.html#map_list/3","title":"BinCodex.map_list/3","type":"function"},{"doc":"Uses a map to convert a codecs results. The map MUST NOT have duplicate values or converting back becomes ambiguous. Examples iex&gt; codec = list ( byte ( ) |&gt; mapping ( %{ 1 =&gt; &quot;a&quot; , 2 =&gt; &quot;b&quot; , 3 =&gt; &quot;c&quot; } ) ) ...&gt; &lt;&lt; 1 , 2 , 3 &gt;&gt; |&gt; decode ( codec ) { :ok , [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; ] , &lt;&lt; &gt;&gt; } ...&gt; [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; ] |&gt; encode ( codec ) { :ok , &lt;&lt; 1 , 2 , 3 &gt;&gt; }","ref":"BinCodex.html#mapping/2","title":"BinCodex.mapping/2","type":"function"},{"doc":"Repeatedly evaluates codec and accumulates the result into a list. Fails if it doesn't successfully evaluate codec at least once. Examples iex&gt; [ 1 , 2 , 3 , 4 ] |&gt; encode ( non_empty_list ( byte ( ) ) ) { :ok , &lt;&lt; 1 , 2 , 3 , 4 &gt;&gt; } iex&gt; [ ] |&gt; encode ( non_empty_list ( byte ( ) ) ) { :error , &quot;Failed to encode []&quot; } iex&gt; &lt;&lt; 1 , 2 , 3 , 4 &gt;&gt; |&gt; decode ( non_empty_list ( byte ( ) ) ) { :ok , [ 1 , 2 , 3 , 4 ] , &lt;&lt; &gt;&gt; } iex&gt; &lt;&lt; &gt;&gt; |&gt; decode ( non_empty_list ( byte ( ) ) ) { :error , &quot;Could not decode 8 bits from \\&quot; \\&quot; &quot; , &lt;&lt; &gt;&gt; }","ref":"BinCodex.html#non_empty_list/1","title":"BinCodex.non_empty_list/1","type":"function"},{"doc":"Inverts a boolean codec. Examples iex&gt; &lt;&lt; 38 &gt;&gt; |&gt; decode ( not_ ( recover ( byte ( ) ) ) ) { :ok , false , &lt;&lt; &gt;&gt; } iex&gt; &lt;&lt; 1 :: 1 &gt;&gt; |&gt; decode ( not_ ( recover ( byte ( ) ) ) ) { :ok , true , &lt;&lt; 1 :: 1 &gt;&gt; }","ref":"BinCodex.html#not_/1","title":"BinCodex.not_/1","type":"function"},{"doc":"A codec that always decodes to nil . It can never fail decoding. Examples iex&gt; optional_byte = byte ( ) |&gt; fallback ( nothing ( ) ) ...&gt; &lt;&lt; 8 &gt;&gt; |&gt; decode ( optional_byte ) { :ok , 8 , &lt;&lt; &gt;&gt; } ...&gt; &lt;&lt; 8 :: 4 &gt;&gt; |&gt; decode ( optional_byte ) { :ok , nil , &lt;&lt; 8 :: 4 &gt;&gt; }","ref":"BinCodex.html#nothing/0","title":"BinCodex.nothing/0","type":"function"},{"doc":"Creates a codec that might not work. If it fails decoding it returns nil instead. Examples iex&gt; &lt;&lt; 11 &gt;&gt; |&gt; decode ( optional ( byte ( ) ) ) { :ok , 11 , &lt;&lt; &gt;&gt; } iex&gt; &lt;&lt; 1 :: 4 &gt;&gt; |&gt; decode ( optional ( byte ( ) ) ) { :ok , nil , &lt;&lt; 1 :: 4 &gt;&gt; }","ref":"BinCodex.html#optional/1","title":"BinCodex.optional/1","type":"function"},{"doc":"Pads the bitstring before decoding. Examples iex&gt; &lt;&lt; 1 :: 1 &gt;&gt; |&gt; decode ( bit ( ) |&gt; pad ( 2 ) ) { :ok , 4 , &lt;&lt; &gt;&gt; } # It&#39;s as if you padded it with two zero bits on the right: iex&gt; &lt;&lt; 1 :: 1 , 0 :: 1 , 0 :: 1 &gt;&gt; |&gt; decode ( bits ( 3 ) ) { :ok , 4 , &lt;&lt; &gt;&gt; } iex&gt; 4 |&gt; encode ( bit ( ) |&gt; pad ( 2 ) ) { :ok , &lt;&lt; 1 :: 1 &gt;&gt; }","ref":"BinCodex.html#pad/2","title":"BinCodex.pad/2","type":"function"},{"doc":"Creates a codec that decodes without actually consuming the bits. Examples iex&gt; &lt;&lt; 4 &gt;&gt; |&gt; decode ( peek ( byte ( ) ) ) { :ok , 4 , &lt;&lt; 4 &gt;&gt; } iex&gt; codec = peek ( byte ( ) ) |&gt; combine ( byte ( ) ) ...&gt; &lt;&lt; 4 &gt;&gt; |&gt; decode ( codec ) { :ok , { 4 , 4 } , &lt;&lt; &gt;&gt; } ...&gt; { 4 , 4 } |&gt; encode ( codec ) { :ok , &lt;&lt; 4 &gt;&gt; }","ref":"BinCodex.html#peek/1","title":"BinCodex.peek/1","type":"function"},{"doc":"Tests whether a codec would succeed. Decodes to true if it would, false otherwise. Examples iex&gt; &lt;&lt; 38 &gt;&gt; |&gt; decode ( recover ( byte ( ) ) ) { :ok , true , &lt;&lt; &gt;&gt; } iex&gt; &lt;&lt; 1 :: 1 &gt;&gt; |&gt; decode ( recover ( byte ( ) ) ) { :ok , false , &lt;&lt; 1 :: 1 &gt;&gt; }","ref":"BinCodex.html#recover/1","title":"BinCodex.recover/1","type":"function"},{"doc":"Fails a codec if the result satisfies the predicate. Examples iex&gt; codec = byte ( ) |&gt; refute ( &amp; &amp;1 &gt; 10 , &quot;Can&#39;t be greater than 10&quot; ) ...&gt; 11 |&gt; encode ( codec ) { :error , &quot;Can&#39;t be greater than 10&quot; } ...&gt; 5 |&gt; encode ( codec ) { :ok , &lt;&lt; 5 &gt;&gt; } ...&gt; &lt;&lt; 11 &gt;&gt; |&gt; decode ( codec ) { :error , &quot;Can&#39;t be greater than 10&quot; } ...&gt; &lt;&lt; 5 &gt;&gt; |&gt; decode ( codec ) { :ok , 5 , &lt;&lt; &gt;&gt; }","ref":"BinCodex.html#refute/3","title":"BinCodex.refute/3","type":"function"},{"doc":"Reverses a list codec. Examples iex&gt; codec = list ( byte ( ) ) |&gt; reverse ( ) ...&gt; [ 1 , 2 , 3 ] |&gt; encode ( codec ) { :ok , &lt;&lt; 3 , 2 , 1 &gt;&gt; } ...&gt; &lt;&lt; 3 , 2 , 1 &gt;&gt; |&gt; decode ( codec ) { :ok , [ 1 , 2 , 3 ] , &lt;&lt; &gt;&gt; }","ref":"BinCodex.html#reverse/1","title":"BinCodex.reverse/1","type":"function"},{"doc":"Combines a list of codecs into a single codec that produces a list of those values. Examples iex&gt; codec = sequence ( [ byte ( ) , byte ( ) , byte ( ) ] ) ...&gt; &lt;&lt; 0x10 , 0xFF , 0xAB &gt;&gt; |&gt; decode ( codec ) { :ok , [ 16 , 255 , 171 ] , &lt;&lt; &gt;&gt; } ...&gt; [ 16 , 255 , 171 ] |&gt; encode ( codec ) { :ok , &lt;&lt; 0x10 , 0xFF , 0xAB &gt;&gt; }","ref":"BinCodex.html#sequence/1","title":"BinCodex.sequence/1","type":"function"},{"doc":"Keeps accumulating codec in a list until boolean_codec evaluates to true. Examples iex&gt; codec = take_until ( bool_bit ( ) , byte ( ) ) ...&gt; &lt;&lt; 0 :: 1 , 7 , 0 :: 1 , 8 , 1 :: 1 &gt;&gt; |&gt; decode ( codec ) { :ok , [ 7 , 8 ] , &lt;&lt; &gt;&gt; } ...&gt; [ 7 , 8 ] |&gt; encode ( codec ) { :ok , &lt;&lt; 0 :: 1 , 7 , 0 :: 1 , 8 , 1 :: 1 &gt;&gt; }","ref":"BinCodex.html#take_until/2","title":"BinCodex.take_until/2","type":"function"},{"doc":"Keeps accumulating codec in a list while boolean_codec evaluates to true. Examples iex&gt; codec = take_while ( bool_bit ( ) , byte ( ) ) ...&gt; &lt;&lt; 1 :: 1 , 7 , 1 :: 1 , 8 , 0 :: 1 &gt;&gt; |&gt; decode ( codec ) { :ok , [ 7 , 8 ] , &lt;&lt; &gt;&gt; } ...&gt; [ 7 , 8 ] |&gt; encode ( codec ) { :ok , &lt;&lt; 1 :: 1 , 7 , 1 :: 1 , 8 , 0 :: 1 &gt;&gt; }","ref":"BinCodex.html#take_while/2","title":"BinCodex.take_while/2","type":"function"},{"doc":"Use the result of a codec to create the next codec. Examples iex&gt; length = byte ( ) ...&gt; length_prefixed = length |&gt; then ( &amp; list_of ( &amp;1 , byte ( ) ) , &amp; length / 1 ) ...&gt; &lt;&lt; 4 , 1 , 2 , 3 , 4 &gt;&gt; |&gt; decode ( length_prefixed ) { :ok , [ 1 , 2 , 3 , 4 ] , &lt;&lt; &gt;&gt; } ...&gt; [ 1 , 2 , 3 , 4 ] |&gt; encode ( length_prefixed ) { :ok , &lt;&lt; 4 , 1 , 2 , 3 , 4 &gt;&gt; }","ref":"BinCodex.html#then/3","title":"BinCodex.then/3","type":"function"},{"doc":"A codec that always decodes to a certain value. It never consumes bits while decoding so it can't fail. It can fail on encoding if the value to encode doesn't match. Examples iex&gt; &lt;&lt; &gt;&gt; |&gt; decode ( value ( 10 ) ) { :ok , 10 , &lt;&lt; &gt;&gt; } iex&gt; &lt;&lt; 200 &gt;&gt; |&gt; decode ( value ( 10 ) ) { :ok , 10 , &lt;&lt; 200 &gt;&gt; } iex&gt; 10 |&gt; encode ( value ( 10 ) ) { :ok , &lt;&lt; &gt;&gt; } iex&gt; 22 |&gt; encode ( value ( 10 ) ) { :error , &quot;22 did not equal 10 in constant&quot; }","ref":"BinCodex.html#value/1","title":"BinCodex.value/1","type":"function"},{"doc":"","ref":"BinCodex.html#t:boolean_codec/0","title":"BinCodex.boolean_codec/0","type":"type"},{"doc":"","ref":"BinCodex.html#t:codec/1","title":"BinCodex.codec/1","type":"type"},{"doc":"","ref":"BinCodex.html#t:decode_result/1","title":"BinCodex.decode_result/1","type":"type"},{"doc":"","ref":"BinCodex.html#t:decoder/1","title":"BinCodex.decoder/1","type":"type"},{"doc":"","ref":"BinCodex.html#t:encode_result/0","title":"BinCodex.encode_result/0","type":"type"},{"doc":"","ref":"BinCodex.html#t:encoder/1","title":"BinCodex.encoder/1","type":"type"},{"doc":"","ref":"BinCodex.html#t:list_codec/1","title":"BinCodex.list_codec/1","type":"type"},{"doc":"","ref":"BinCodex.html#t:remaining_bits/0","title":"BinCodex.remaining_bits/0","type":"type"},{"doc":"","ref":"BinCodex.html#t:type/0","title":"BinCodex.type/0","type":"type"},{"doc":"","ref":"BinCodex.html#t:type2/0","title":"BinCodex.type2/0","type":"type"},{"doc":"","ref":"BinCodex.Base.Base16.html","title":"BinCodex.Base.Base16","type":"module"},{"doc":"","ref":"BinCodex.Base.Base16.html#codec/0","title":"BinCodex.Base.Base16.codec/0","type":"function"},{"doc":"","ref":"BinCodex.Base.Base32.html","title":"BinCodex.Base.Base32","type":"module"},{"doc":"","ref":"BinCodex.Base.Base32.html#codec/0","title":"BinCodex.Base.Base32.codec/0","type":"function"},{"doc":"","ref":"BinCodex.Base.Base64.html","title":"BinCodex.Base.Base64","type":"module"},{"doc":"","ref":"BinCodex.Base.Base64.html#codec/0","title":"BinCodex.Base.Base64.codec/0","type":"function"},{"doc":"","ref":"BinCodex.Gve.html","title":"BinCodex.Gve","type":"module"},{"doc":"","ref":"BinCodex.Gve.html#codec/0","title":"BinCodex.Gve.codec/0","type":"function"},{"doc":"","ref":"BinCodex.Util.html","title":"BinCodex.Util","type":"module"},{"doc":"","ref":"BinCodex.Util.html#bits_to_int/1","title":"BinCodex.Util.bits_to_int/1","type":"function"},{"doc":"","ref":"BinCodex.Util.html#join/2","title":"BinCodex.Util.join/2","type":"function"},{"doc":"","ref":"BinCodex.Util.html#remove_leading_zeros/1","title":"BinCodex.Util.remove_leading_zeros/1","type":"function"},{"doc":"","ref":"BinCodex.Util.html#reverse_bits/1","title":"BinCodex.Util.reverse_bits/1","type":"function"},{"doc":"","ref":"BinCodex.Util.html#split/2","title":"BinCodex.Util.split/2","type":"function"},{"doc":"","ref":"BinCodex.Varint.html","title":"BinCodex.Varint","type":"module"},{"doc":"","ref":"BinCodex.Varint.html#codec/0","title":"BinCodex.Varint.codec/0","type":"function"}]